%global srcname synapse

%{?python_enable_dependency_generator}

Name:       matrix-%{srcname}
Version:    0.33.3.1
Release:    1%{?dist}
Summary:    A Matrix reference homeserver written in Python using Twisted
License:    ASL 2.0
URL:        https://github.com/matrix-org/%{srcname}
Source0:    %{url}/archive/v%{version}/%{srcname}-%{version}.tar.gz
Source1:    synapse.sysconfig
Patch0:     Drop-the-unshipped-web_client-dependency.patch
BuildArch:  noarch

BuildRequires:  python2-devel
BuildRequires:  python2-setuptools
BuildRequires:  python2-sphinx
BuildRequires:  python2-affinity
BuildRequires:  python2-bcrypt
BuildRequires:  python2-pyOpenSSL >= 0.15
BuildRequires:  python2-bleach >= 1.4.2
BuildRequires:  python2-blist
BuildRequires:  python2-canonicaljson >= 1.1.3
BuildRequires:  python2-daemonize
BuildRequires:  python2-frozendict >= 0.4
BuildRequires:  python2-jinja2 >= 2.8
BuildRequires:  python2-jsonschema
BuildRequires:  python2-lxml
BuildRequires:  python2-matrix-synapse-ldap3 >= 0.1
BuildRequires:  python2-msgpack >= 0.3.0
BuildRequires:  python2-netaddr >= 0.7.18
BuildRequires:  python2-phonenumbers >= 8.2.0
BuildRequires:  python2-pillow
BuildRequires:  python2-psutil >= 2.0.0
BuildRequires:  python2-pyasn1
BuildRequires:  python2-pydenticon
BuildRequires:  python2-pymacaroons-pynacl
BuildRequires:  python2-pynacl >= 1.2.0
BuildRequires:  python2-pysaml2 >= 3.0.0
BuildRequires:  python2-service-identity >= 1.0.0
BuildRequires:  python2-signedjson >= 1.0.0
BuildRequires:  python2-six
BuildRequires:  python2-sortedcontainers
BuildRequires:  python2-systemd
BuildRequires:  python2-twisted >= 16.0.0
BuildRequires:  python2-ujson
BuildRequires:  python2-unpaddedbase64 >= 1.1.0
BuildRequires:  python2-prometheus_client
BuildRequires:  python2-pyyaml
BuildRequires:  systemd
BuildRequires:  python2-mock

Requires(pre):  shadow-utils
Requires:       systemd
%{?systemd_requires}

%description
Matrix is an ambitious new ecosystem for open federated Instant Messaging and
VoIP. Synapse is a reference "homeserver" implementation of Matrix from the
core development team at matrix.org, written in Python/Twisted. It is intended
to showcase the concept of Matrix and let folks see the spec in the context of
a coded base and let you run your own homeserver and generally help bootstrap
the ecosystem.


%prep
%autosetup -p1 -n %{srcname}-%{version}

# We don't support the built-in client so remove all the bundled JS.
rm -rf synapse/static


%build
%py2_build


%install
%py2_install

install -p -D -T -m 0644 contrib/systemd/log_config.yaml %{buildroot}%{_sysconfdir}/synapse/log_config.yaml
install -p -D -T -m 0644 contrib/systemd/synapse.service %{buildroot}%{_unitdir}/synapse.service
install -p -D -T -m 0644 %{SOURCE1} %{buildroot}%{_sysconfdir}/sysconfig/synapse
install -p -d -m 755 %{buildroot}/%{_sharedstatedir}/synapse


%check
PYTHONPATH=. trial-2 tests


%pre
getent group synapse >/dev/null || groupadd -r synapse
getent passwd synapse >/dev/null || \
    useradd -r -g synapse -d %{_sharedstatedir}/synapse -s /sbin/nologin \
    -c "The user for the Synapse Matrix server" synapse
exit 0

%post
%systemd_post synapse.service

%preun
%systemd_preun synapse.service

%postun
%systemd_postun_with_restart synapse.service


%files
%license LICENSE
%doc *.rst
%dir %{_sysconfdir}/synapse
%config(noreplace) %{_sysconfdir}/synapse/*
%config(noreplace) %{_sysconfdir}/sysconfig/synapse
%{python2_sitelib}/synapse/
%{python2_sitelib}/matrix_synapse*.egg-info/
%{_bindir}/*
%{_unitdir}/synapse.service
%attr(755,synapse,synapse) %dir %{_sharedstatedir}/synapse


%changelog
* Thu Sep 06 2018 Jeremy Cline <jeremy@jcline.org> - 0.33.3.1-1
- Update to v0.33.3.1
- Use the Python dependency generator.

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.31.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Thu Jun 14 2018 Jeremy Cline <jeremy@jcline.org> - 0.31.2-1
- Update to v0.31.2
- https://github.com/matrix-org/synapse/releases/tag/v0.31.2

* Wed Jun 13 2018 Jeremy Cline <jeremy@jcline.org> - 0.31.1-2
- Stop using Python dependency generator

* Wed Jun 13 2018 Jeremy Cline <jeremy@jcline.org> - 0.31.1-1
- Update to v0.31.1
- Fix CVE-2018-12291

* Thu May 24 2018 Jeremy Cline <jeremy@jcline.org> - 0.29.1-1
- Update to the latest upstream release.
- Use the Python dependency generator.

* Tue May 01 2018 Jeremy Cline <jeremy@jcline.org> - 0.28.1-1
- Update to the latest upstream release.

* Wed Apr 11 2018 Jeremy Cline <jeremy@jcline.org> - 0.27.3-1
- Update to the latest upstream release.

* Mon Mar 26 2018 Jeremy Cline <jeremy@jcline.org> - 0.27.2-1
- Update to the latest upstream release.

* Thu Feb 08 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.26.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Wed Jan 10 2018 Jeremy Cline <jeremy@jcline.org> - 0.26.0-1
- Update to latest upstream

* Tue Jan 09 2018 Iryna Shcherbina <ishcherb@redhat.com> - 0.23.1-2
- Update Python 2 dependency declarations to new packaging standards
  (See https://fedoraproject.org/wiki/FinalizingFedoraSwitchtoPython3)

* Tue Oct 03 2017 Jeremy Cline <jeremy@jcline.org> - 0.23.1-1
- Update to latest upstream
- Include patch to work with ujson-2.0+

* Fri Sep 29 2017 Igor Gnatenko <ignatenkobrain@fedoraproject.org> - 0.22.1-4
- Use python2 prefix for packages whenever possible
- Add missing %%{?systemd_requires}

* Wed Aug 09 2017 Gwyn Ciesla <limburgher@gmail.com> - 0.22.1-3
- Switch to python-bcrypt, BZ 1473018.

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.22.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Mon Jul 10 2017 Jeremy Cline <jeremy@jcline.org> - 0.22.1-1
- Update to the latest upstream release

* Thu Jul 06 2017 Jeremy Cline <jeremy@jcline.org> - 0.22.0-1
- Update to the latest upstream release (#1462045)

* Fri Jun 23 2017 Jeremy Cline <jeremy@jcline.org> - 0.21.1-1
- Update to latest upstream release

* Tue May 30 2017 Jeremy Cline <jeremy@jcline.org> - 0.19.3-4
- use _sharedstatedir  rather than _localstatedir

* Wed May 17 2017 Jeremy Cline <jeremy@jcline.org> - 0.19.3-3
- Remove bundled JS
- Fix some typos in the summary and description

* Tue Apr 04 2017 Jeremy Cline <jeremy@jcline.org> - 0.19.3-2
- Remove the duplicate requirement on pysaml

* Tue Mar 28 2017 Jeremy Cline <jeremy@jcline.org> - 0.19.3-1
- Initial package
